<?
include ("common.php");

function create_db_table () {
  global $db;

  $mysql_create_table = 
    "CREATE TABLE IF NOT EXISTS TowerData ".
    "(".
    "uid CHAR (64) NOT NULL PRIMARY KEY,".
    "oper            CHAR (6),".
    "lac	     CHAR (4),".
    "cid             CHAR (4),".
    "name            CHAR (64),".
    "address         CHAR (255),".
    "city            CHAR (64),".
    "state           CHAR (3),".
    "latitude        CHAR (64),".
    "longitude       CHAR (64),".
    "isTowerLocation ENUM (\"false\",\"true\"),".
    "signalStrength  CHAR (64),".
    "asu             TINYINT," .
    "dbm             SMALLINT"  .
    ")";
  mysql_query ($mysql_create_table,$db) or die ("Invalid mysql command: ".mysql_error() . "<br>\n");
};

# function parse_lat_or_long ($lat_or_long) {
#   /* Acceptable input is a string of one of the following format
#    0) 37       means degrees 
#    1) 37.12345 and that should be converted to a float
#    2) 37 24    means 37 degrees, 24 minutes
#    3) 37 24.56 means 37 degrees, 24.56 minutes. Divide the minutes by 60 and add to degrees
#    4) 37 25 33 means 37 degrees 25 minutes, 30 seconds. Divide the seconds (33) by 60, then add to minutes (25) then do case # 2
#    5) 37 25 33.56 means 37 degrees 25 minutes, 30 seconds. Divide the seconds (33.56) by 60, then add to minutes (25) then do case # 2
#   */
#
#   $pieces = explode (" ",$lat_or_long);
#   if (count($pieces) == 1) {
#     // Just 37 or 37.12345
#     $case0_or_1 = "|\d{1,3}[\.\d+]$|";  // ddd OR ddd.d+
#     if (preg_match ($case0_or_1,$lat_or_long)) {
#       echo $lat_or_long, " is case 0 or 1<br>";    
#       //return (floatval($lat_or_long));
#       return ($lat_or_long);
#     };
#   } else {
#     // 1 or more spaces. First pieces must be the minutes
#     $minutes = $pieces[0];
#     // Now parse what is left. It's either 24, 24.56, 25 33 or 25 33.56
#     $minute_pieces = explode(" ",$pieces[1]);
#     if (count($minute_pieces) == 1) {
#       // No spaces. Must be case 2 or 3
#       $case2_or_3 = "|^(\d{1,2})[\.(\d{1,2})]{0,1}$|"; // dd dd OR dd dd.dd
#       if (preg_match ($case2_or_3,$pieces[1],$matches)) {
# 	echo "debug: matched case 2 or 3<br>\n";
# 	echo "matches[1] is ",$matches[1],"<br>";
# 	if (intval($matches[1]) < 60) {
# 	  echo "seconds are ",$matches[1];
# 	  if (! $matches[2]) {
# 	    return ($lat_or_long);
# 	  } elseif (intval($matches[2]) < 60) {
# 	    echo $lat_or_long, " is case 2 or 3<br>";
# 	    // $temp = floatval($minutes) + floatval($pieces[1]) / 60;
# 	    return ($lat_or_long);
# 	  };
# 	};
#       };
#     } else {
#       // Must be case 4 or 5
#       $case4_or_5 = "|(\d{1,2}[\.\d+])|"; // ddd dd dd OR ddd dd dd.ddddd
#       if (preg_match ($case3_or_4,$pieces[2])) {
# 	echo $lat_or_long, " is case 4 or 5<br>";
# 	//$temp = floatval($pieces[0]) + (floatval($pieces[1]) + (floatval($pieces[3]) / 60) / 60);
# 	return ($lat_or_long);
#       };
#     };
#   };
#
#   echo "Oops. We don't understand the latitude/longitude format ",$lat_or_long,"<br>\n";
#   return 0;
# };

function parse_lat_or_long ($lat_or_long) {
  return ($lat_or_long);
};


  /* This is what */
  $y = 3;
};

#########################
#  Main Program
##########################
global $db;

open_db();
create_db_table ();

if ($REQUEST_METHOD == "POST") {
  if (! isset ($isTowerLocation)) {
    $isTowerLocation = "false";
  };

  # parse the latitude and longitude
  if (isset ($latitude)) {
    $latitude = parse_lat_or_long ($latitude);
  };

  if (isset ($longitude)) {
    $longitude = parse_lat_or_long ($longitude);
  };

  $result = do_db_update ($uid,$oper,$lac,$cid,$name,$address,$city,$state,$latitude,$longitude,$isTowerLocation,$signalStrength,$asu,$dbm);
  Header("Content-type: text/plain");
  echo "uid=$result";

} else {
  // REQUEST_METHOD is GET so offer an editable form
  // Get the values first
  if ($uid != "") {
    $query = "SELECT * FROM TowerData where uid='".addslashes($uid)."'";
    $results = mysql_query ($query,$db) or die ("Invalid mysql command: ".mysql_error() . "<br>\n");
    if (mysql_num_rows ($results) > 1) {
      die ("Our query $query did not match 1 row exactly. It matched ".mysql_num_rows ($results)." rows");
    };
    
    list ($db_uid,$db_oper,$db_lac,$db_cid,$db_name,$db_address,$db_city,$db_state,$db_latitude,$db_longitude,$db_isTowerLocation,$db_signalStrength,$db_asu,$db_dbm) = mysql_fetch_row ($results);
    echo "<h1>Information for uid ",$uid,"</h1>\n";
  } else {
    $db_uid = ""; // ?????
    $oper = "";
    $lac = "";
    $cid = "";
    $name = "";
    $address = "";
    $city = "";
    $state = "";
    $latitude = "";
    $longitude = "";
    $isTowerLocation = false;
    $signalStrength = "";
    $asu = 0;
    $dbm = 0;
  };
  // If the user specified values on the command line then these will override the db values

  if (isset ($oper)) { $db_oper = $oper; };
  if (isset ($lac))  { $db_lac  = $lac; };
  if (isset ($cid))  { $db_cid  = $cid; };
  if (isset ($name))  { $db_name  = $name; };
  if (isset ($address))  { $db_address  = $address; };
  if (isset ($city))  { $db_city  = $city; };
  if (isset ($state))  { $db_state  = $state; };
  if (isset ($latitude)) { $db_latitude = $latitude; };
  if (isset ($longitude))  { $db_longitude  = $longitude; };
  if (isset ($isTowerLocation))  { $db_isTowerLocation  = $isTowerLocation; };
  if (isset ($signalStrength))  { $db_signalStrength  = $signalStrength; };
  if (isset ($asu))  { $db_asu  = $asu; };
  if (isset ($dbm))  { $db_dbm  = $dbm; };


  echo <<<END

  <form action="update.php" method="post">
  <table>
  <input type="hidden" name="uid" value="$db_uid">
  <tr><td>Oper:</td> 
      <td><input type="text" name="oper" value="$db_oper"></td>
  </tr>

  <tr><td>Lac:</td>
      <td><input type="text" name="lac"  value="$db_lac"></td>
  </tr>

  <tr><td>cid:</td>
      <td><input type="text" name="cid"  value="$db_cid"></td>
  </tr>

  <tr><td>Name:</td>
      <td><input type="text" name="name"  value="$db_name"></td>
  </tr>

  <tr><td>Address:</td>
      <td><input type="text" name="address"  value="$db_address"></td>
  </tr>

  <tr><td>City:</td>
      <td><input type="text" name="city"  value="$db_city"></td>
  </tr>

  <tr><td>State:</td>
      <td><input type="text" name="state"  value="$db_state"></td>
  </tr>

  <tr><td>Latitude:</td>
      <td><input type="text" name="latitude"  value="$db_latitude"></td>
  </tr>

  <tr><td>Longitude:</td>
      <td><input type="text" name="longitude"  value="$db_longitude"></td>
  </tr>
  <tr><td>Is this Tower Location?:</td>
END;
    if ($db_isTowerLocation == "true") {

      echo "<td><input type=\"radio\" name=\"isTowerLocation\"  checked=\"checked\" value=\"true\"> Yes</td>\n";
      echo "<td><input type=\"radio\" name=\"isTowerLocation\"  value=\"false\"> No</td>\n";
    } else {
      echo "<td><input type=\"radio\" name=\"isTowerLocation\"  value=\"true\"> Yes</td>\n";
      echo "<td><input type=\"radio\" name=\"isTowerLocation\"  checked=\"checked\" value=\"false\"> No</td>\n";
    };
    echo <<<END
      </tr>

   <tr><td>Signal Strength</td>
       <td><input type="text" name="signalStrength"  value="$db_signalStrength"></td>
   </tr>

 <tr><td>ASU</td>
       <td><input type="text" name="asu"  value="$db_asu"></td>
   </tr>

 <tr><td>dbm</td>
       <td><input type="text" name="dbm"  value="$db_dbm"></td>
   </tr>


      </table>
      <input type="submit" value="Make changes">
     </form>
END;
};

?>
